import { urls } from '../config/web.config';
import getAuthCode from '../utils/getAuthCode';

const receiveFetchDetail = response => ({
  type: 'RECEIVE_FETCHDETAIL',
  leaveDetail: response
});

export const getFetchDetail = detailId => async (dispatch, getState) => {
  const _headers = {
    'Content-Type': 'application/json'
  };
  const code = await getAuthCode();
  const url = `${urls.detail}${detailId}?code=${code}`;
  window.HWH5.fetchInternet(url, {
    method: 'get',
    headers: _headers
  })
    .then(res => {
      res.json().then(reply => {
        reply.userName = reply.userName === 'null' ? '' : reply.userName;
        dispatch(receiveFetchDetail(reply));
      });
    })
    .catch(error => {
      console.log('请求异常', error);
    });
};

const receiveApproval = response => ({
  type: 'RECEIVE_APPROVAL',
  leaveDetail: response
});

export const setApproval = param => async (dispatch, getState) => {
  const _headers = {
    'Content-Type': 'application/json'
  };
  const code = await getAuthCode();
  const url = `${urls.approve}?code=${code}`;
  const result = await window.HWH5.fetchInternet(url, {
    method: 'post',
    body: JSON.stringify(param),
    headers: _headers
  })
    .then(res => res.json())
    .catch(error => {
      console.log('请求异常', error);
    });
  dispatch(receiveApproval(result));
  return result;
};
