import { urls } from '../config/web.config';
import getAuthCode from '../utils/getAuthCode';
const myListFetch = (type, response) => ({
  type,
  dataList: response
});
// 我的请假列表
export const getLeaveMyList = (uid, status) => async dispatch => {
  try {
    const _headers = {
      'Content-Type': 'application/json'
    };
    const code = await getAuthCode();
    const url = `${urls.mylist}?approveUserId=${uid}&leaveState=${status}&code=${code}`;
    const response = await window.HWH5.fetchInternet(url, { method: 'get', headers: _headers })
      .then(res => res.json())
      .then(reply => reply)
      .catch(error => {
        console.log('请求异常', error);
      });
    await dispatch(myListFetch('LEAVE_MYLIST', response));
    return response;
  } catch (error) {
    return error;
  }
};

// 待我审批列表
export const getApproveList = aid => async dispatch => {
  try {
    const _headers = {
      'Content-Type': 'application/json'
    };
    const code = await getAuthCode();
    const url = `${urls.approvelist}?approveUserId=${aid}&leaveState=0&code=${code}`;
    const response = await window.HWH5.fetchInternet(url, { method: 'get', headers: _headers })
      .then(res => res.json())
      .then(reply => reply)
      .catch(error => {
        console.log('请求异常', error);
      });
    await dispatch(myListFetch('LEAVE_APPROVELIST', response));
    return response;
  } catch (error) {
    return error;
  }
};

export const setDetailid = (type, detailId) => async dispatch => {
  await dispatch(myListFetch('LEAVE_MYDETAIL', { type, detailId }));
};

export const changeStatus = newStatus => async dispatch => {
  await await dispatch({ type: 'CHANGE_STATUS', status: newStatus });
};

export const changeTab = newTab => async dispatch => {
  await await dispatch({ type: 'CHANGE_TAB', tab: newTab });
};
