import React from 'react';
import moment from 'moment';
import PropTypes from 'prop-types';
import './index.less';
import { Input } from '@wecode/react-weui';
import i18n from 'i18n';

export default class DateTimeLocal extends React.Component {
  handleOnChange = () => {
    const {
      title, type, value = '', onChange 
    } = this.props;
    const date = value === '' || value === 'null' ? new Date() : new Date(value.replace(/-/g, '/'));
    const datetime = date.getTime();
    window.HWH5.selectDate
      && window.HWH5.selectDate({
        title,
        datetime,
        format: 'yyyy-MM-dd HH:mm'
      })
        .then(data => {
          if (data && data.date) onChange(type, data.date);
        })
        .catch(_err => {
          console.log('日历控件报错', _err);
        });
  };

  handleIOSOnChange = value => {
    const { onChange, type } = this.props;
    if (onChange) onChange(type, this.handelDateTime(value));
  };

  handelDateTime = date => (typeof date !== 'undefined' && date !== '' && date !== 0
    ? moment(date).format('YYYY-MM-DD HH:mm')
    : '');

  render() {
    const { value } = this.props;
    return (
      <div>
        {HWH5.platform === 'iOS' && (
          <div className="am-modal-input date-time-local-bg">
            <input
              className="date-time_view"
              type="datetime-local"
              onChange={e => this.handleIOSOnChange(e.target.value)}
            />
            <Input
              className="date-text-right"
              type="text"
              value={this.handelDateTime(value)}
              placeholder={i18n.t('common:timePlaceHolder')}
              readOnly
            />
          </div>
        )}
        {HWH5.platform !== 'iOS' && (
          <div
            className="am-modal-input date-time-local-bg"
            onClick={this.handleOnChange.bind(this)}
          >
            <Input
              className="date-text-right"
              type="text"
              value={this.handelDateTime(value)}
              placeholder={i18n.t('common:timePlaceHolder')}
              readOnly
            />
          </div>
        )}
      </div>
    );
  }
}
DateTimeLocal.propTypes = {
  type: PropTypes.string,
  title: PropTypes.string,
  value: PropTypes.string,
  onChange: PropTypes.func
};
