import React from 'react';
import PropTypes from 'prop-types';
import './index.less';

const IconBox = props => {
  const {
    imgstr, title, clsName, _onClick
  } = props;
  return (
    <span className={clsName} onClick={_onClick}>
      <p className="tip"> {imgstr}</p>
      <p className="tit">{title}</p>
    </span>
  );
};

IconBox.propTypes = {
  _onClick: PropTypes.func,
  clsName: PropTypes.string,
  imgstr: PropTypes.object,
  title: PropTypes.string
};

export default IconBox;
