import React from 'react';
import PropTypes from 'prop-types';
import i18n from 'i18n';
import './index.less';
import moment from 'moment';
const renderDem = (data, tab, index, onClick)=> (
  <div key={index} className="list_box__hd" style={{ paddingBottom: 12 }} onClick={()=> (onClick ? onClick(data.id) : ()=>{})}>
    <div className="list_box__hd_title">
      <div className="list_box__hd_title_left">{`${data.leaveType}`}</div>
      <div className="list_box__hd_title_right">{`${data.createTime}`}</div>
    </div>  
    <div className="list_box__hd_body">
      <div className="list_box__hd_body_left">
        <div className="list_box_hd_body_detail">
          <div>
            <span>
              { tab === 1 ? `${i18n.t('common:applicant')}：` : (data.applyState === 1 ? `${i18n.t('common:listApprover')}：` : `${i18n.t('common:operator')}：`) }
            </span>
            <span>
              { tab === 1 ? `${data.userName}` : `${data.leaderName}`}
            </span>
          </div>
          <div><span>{`${i18n.t('common:time')}：`}</span><span>{`${moment(data.beginTime).format('YYYY-MM-DD HH:mm')} ~ ${moment(data.endTime).format('YYYY-MM-DD HH:mm')}`}</span></div>
        </div>
      </div>
      <div className="list_box__hd_body_right">
        <span className={`list_box__hd_body_status${'_' + data.stateKey}`}>{data.currentState}</span>
      </div>
    </div>
  </div>
);

const ListBox = props=>{
  const { data, tab, onClick } = props;
  return (
    <div className="list_box__bg">
      {
        data.map((param, index)=>renderDem(param, tab, index, onClick))
      }
    </div>
  );
};

ListBox.propTypes = {
  data: PropTypes.array,
  onClick: PropTypes.func,
  tab: PropTypes.number
};

export default ListBox;
