import moment from 'moment';
// 请假时间计算
const diffDay = function (startDate, endDate) {
  if (!startDate || !endDate) return { day: 0, hours: 0 };
  if (moment(endDate).isSameOrBefore(moment(startDate))) {    
    // window.HWH5.toast({ msg: '开始时间在结束时间之前', type: 'w' });
    return { day: 0, hours: 0 };
  }
  const times = moment.duration(moment(endDate) - moment(startDate), 'ms');

  const minute = times / 1000 / 60;
  let hours = minute / 60;

  let day = hours / 24;
  day = parseFloat(day);
  
  if (day >= 1) {
    let dayNum = day.toFixed(0);
    let hours2 = (day + '').split('.')[1];
    if (hours2) {
      hours2 = parseFloat('0.' + hours2);
      hours2 = hours2 * 24;
      hours2 = hours2.toFixed(1);
    } else {
      hours2 = 0;
    }
    console.log(dayNum, '天', hours2, '小时', minute, '分钟');
    dayNum = parseFloat(dayNum);
    hours2 = parseFloat(hours2);
    return { day: dayNum, hours: hours2 };
  } else {
    hours = hours.toFixed(1);
    hours = parseFloat(hours);
    if (Number.isNaN(hours) || Number.isNaN(minute)) {
      return { day: 0, hours: 0 };
    }
    return { day: 0, hours };
  }
};

export default diffDay;
