#工程介绍#


- 本工基于maven+ springboot+jpa+mysql/h2构建，


- 分为Controller，Service 和 DAO三层


- 主要功能：为请假We码提供服务，并实现与CloudLink WorkPlace的免登流程，具体见 FreeAccessHelper类。
具体功能包括，新建请假，可保存草稿，查看请假详情，查看请假列表，查看审批列表以及审批请假
#启动本工程说明#
 

- 下载本工程 源码，通过Eclipse导入工程 
    Eclipse->File->Import->选择"Existing Maven Projects"

- 选择本工程 ，导入成功，根据需要修改相关配置
- 	修改服务端口，默认配置为：9999
- 	修改日志目录log4j.properties 配置文件 ，默认/log/
- 	修改数据库，默认h2 数据库内存模式
- 	修改wecode.info.appId和wecode.info.appSecret，此值通过在开放平台注册We码所得


# 配置说明 #
##公共配置文件application.properties说明##
    server.port=9999
    logging.config=classpath:log4j.properties
    logging.level.org.springframework=DEBUG
    #启用application-h2.properties配置
    spring.profiles.active=h2
    #在CloudLink开放平台 注册We码应用时产生的应用ID 
    wecode.info.appId=20181219175916670
    #在CloudLink开放平台 注册We码应用时产生的应用Secret
    wecode.info.appSecret=2048b0d3-a480-4cf1-ba1c-9fc7c46ffeed
    #获取CloudLink的Token服务地址
    wecode.info.tokenURL=https://cloudlinkworkplace-open.myhuaweicloud.com/api/auth/v1/tickets
    wecode.info.tokenURL=https://cloudlinkworkplace-open.myhuaweicloud.com/api/auth/v1/tickets
    #获取CloudLink的帐号ID服务地址
    wecode.info.userIdURL=https://cloudlinkworkplace-open.myhuaweicloud.com/api/auth/v1/userid
    #获取CloudLink用户详情服务地址
    wecode.info.userInfoURL=https://cloudlinkworkplace-open.myhuaweicloud.com/api/contact/v1/users


##H2数据配置说明##

  application-h2.properties配置说明:主是要H2数据库连接信息

    spring.datasource.platform=h2
    spring.datasource.schema=classpath:db/schema_H2.sql
    spring.h2.console.settings.web-allow-others=true
    spring.h2.console.path=/h2-console
    spring.h2.console.enabled=true
    spring.h2.console.settings.trace=true
    spring.datasource.url=jdbc:h2:mem:oa
    spring.datasource.driver-class-name =org.h2.Driver
    spring.datasource.username=sa
    spring.datasource.password=sa


##mysql数据配置说明##
若使用mysql数据，需要做如下工作

- 创建数据库，如oa
- 始化mysql数据库脚本  db/schema_mysql.sql
- 根据实际情况修改配置

application-mysql.properties配置说明
    pring.datasource.platform=mysql
    spring.datasource.url = jdbc:mysql://127.0.0.1:3306/oa?useUnicode=true&amp;characterEncoding=UTF-8&amp;allowMultiQueries=true&amp;autoReconnect=true&amp;failOverReadOnly=false
    spring.datasource.username = root
    spring.datasource.password = 1qaz@WSX
    spring.jpa.database-platform=org.hibernate.dialect.MySQLDialect




