package com.cloudlink.open.dao;

import java.util.List;

import org.springframework.data.jpa.repository.JpaRepository;
import org.springframework.data.jpa.repository.Query;
import org.springframework.stereotype.Component;

import com.cloudlink.open.model.LeaveModel;

@Component("leaveDAO")
public interface LeaveDAO extends JpaRepository<LeaveModel, String> {
	
	/*@Modifying(clearAutomatically=true)
	@Query("update LeaveModel m set m.beginTime=")
	void updateLeave(LeaveModel model);
*/
	@Query("select m from LeaveModel m where m.leaderId = ?1 and m.isDraft=0 order by m.createTime desc")
	List<LeaveModel> findByLeaderId(String leaderId);

	@Query("select m from LeaveModel m where m.leaderId = ?1 and m.stateKey=?2 and m.isDraft=0 order by m.createTime desc")
	List<LeaveModel> findByLeaderIdAndStateKey(String leaderId, int stateKey);

	@Query("select m from LeaveModel m where m.applyUserId = ?1 and m.isDraft=0  order by m.createTime desc")
	List<LeaveModel> findByApplyUserId(String applyUserId);

	@Query("select m from LeaveModel m where m.applyUserId = ?1 and m.stateKey=?2 and m.isDraft=0 order by m.createTime desc")
	List<LeaveModel> findByApplyUserIdAndStateKey(String applyUserId, int stateKey);
	
	@Query("select m from LeaveModel m where m.applyUserId = ?1 and m.isDraft=1")
	List<LeaveModel> findDraft(String uid);

}
